=== debian/changelog ===
ros-ardent-rcutils (0.4.0-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Karsten Knese <karsten@osrfoundation.org>  Sat, 09 Dec 2017 07:35:31 -0000
