=== debian/control ===
Source: ros-ardent-rcutils
Section: misc
Priority: extra
Maintainer: Karsten Knese <karsten@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), python3-empy, ros-ardent-ament-cmake, ros-ardent-ament-cmake-gmock, ros-ardent-ament-cmake-gtest, ros-ardent-ament-cmake-pytest, ros-ardent-ament-lint-auto, ros-ardent-ament-lint-common, ros-ardent-launch-testing, ros-ardent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-ardent-rcutils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-ardent-ros-workspace
Description: Package containing various utility types and functions for C
